//define lcd parameters
sbit LCD_RS at LATB4_bit;
sbit LCD_EN at LATB5_bit;
sbit LCD_D4 at LATB0_bit;
sbit LCD_D5 at LATB1_bit;
sbit LCD_D6 at LATB2_bit;
sbit LCD_D7 at LATB3_bit;

sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;

int BinaryBuffer[40];
int buffer[42];
//short int converted_byte = 0;
char *text = " 00.0";


short int byte_to_Binary(int array_pointer){
   short int converted_byte = 0;
   converted_byte = 0;

if (BinaryBuffer[array_pointer] == 0)
   converted_byte.B7 = 0;
   else
   converted_byte.B7 = 1;
   array_pointer ++;

if (BinaryBuffer[array_pointer] == 0)
   converted_byte.B6 = 0;
   else
   converted_byte.B6 = 1;
   array_pointer ++;

if (BinaryBuffer[array_pointer] == 0)
   converted_byte.B5 = 0;
   else
   converted_byte.B5 = 1;
   array_pointer ++;
   
if (BinaryBuffer[array_pointer] == 0)
   converted_byte.B4 = 0;
   else
   converted_byte.B4 = 1;
   array_pointer ++;
   
if (BinaryBuffer[array_pointer] == 0)
   converted_byte.B3 = 0;
   else
   converted_byte.B3 = 1;
   array_pointer ++;
   
if (BinaryBuffer[array_pointer] == 0)
   converted_byte.B2 = 0;
   else
   converted_byte.B2 = 1;
   array_pointer ++;
   
if (BinaryBuffer[array_pointer] == 0)
   converted_byte.B1 = 0;
   else
   converted_byte.B1 = 1;
   array_pointer ++;

if (BinaryBuffer[array_pointer] == 0)
   converted_byte.B0 = 0;
   else
   converted_byte.B0 = 1;

return converted_byte;
}

void convert_byte_BIN(){
int index =2, bbindex=0;
//index pointer is offset by 2 due to spurious interupt on timer switch on and
//1 st data is sensor ack pulse then followed by the 40 data bits
// low bit determination bracket is 8Mhz / 4 =fosc
//this is .5 us so prescaller of 4 gives us 2us per timer increment
//sensor range for zero bit is 26 to 28 us so coupled with the 50us high time to next bit
//we get a timer value for 0 bit check twixt 40 to 89 us
// sensor range for one bit is 70us + 50 = 130 us
// we get a timer value for 1 bit check twixt 90 to 160 us
while(index<42){
                if ((buffer[index] > 0x15) && (buffer[index] < 0x30)){
                     BinaryBuffer[bbindex] = 0;
                     }
                if ((buffer[index] > 0x30) && (buffer[index] < 0x50)){
                     BinaryBuffer[bbindex] = 1;
                     }
                index ++;
                bbindex ++;
  }
}

void number_to_str(int valitem){

text[0] = ' ';
if (valitem & 0x8000){ // negative number test
   text[0]= '-';
   }
if (valitem / 100)
   text[1] = valitem /100 + 48;
   else
   text[1] = ' ';
   text[2] = (valitem /10)%10 + 48;
   text[3] = '.';
   text[4] = valitem % 10 + 48;

 uart1_write_text(text);

}
void serial_nlcr(){
uart1_write(0x0d);
uart1_write(0x0a);
}
void data_conversion(){
int debugmode = 0; //set debug mode to 1 to dump data to serial port
short int humid_hi=0, humid_low=0, temp_hi_MM=0, temp_low=0, checksum =0, total = 0;
int humid_value =0, tempcelc_value =0, x=0;

if (portd.B0 == 1){
debugmode = 1;
   }

         humid_hi = byte_to_Binary(0);
         humid_low = byte_to_Binary(8);

         temp_hi_MM = byte_to_Binary(16);
         temp_low = byte_to_Binary(24);

         checksum = byte_to_Binary(32);

         total = humid_hi + humid_low + temp_hi_MM + temp_low;
         if (total != checksum)
            {uart1_Write_text("CheckSum Error");
            }
         if (debugmode ==1) {
            for (x=2; x < 42; x++){
            uart1_write(buffer[x]);

            }
            serial_nlcr();

            for (x=0; x <40; x++)
            {
            uart1_write(BinaryBuffer[x]);
            }
            serial_nlcr();

            uart1_Write(humid_hi);
            uart1_write(humid_low);
            uart1_write(temp_hi_MM);
            uart1_write(temp_low);
            uart1_write(checksum);
            serial_nlcr();
         }

         humid_value = (humid_hi << 8) | (humid_low & 0xff);
         number_to_str(humid_value);
         uart1_write_text (" Humidity");
         serial_nlcr();
         Lcd_out(1,1,"Humidity ");
         Lcd_out_cp(text);
         Lcd_Out_cp("%");

         tempcelc_value = (temp_hi_MM << 8) | (temp_low & 0xff);
         number_to_str(tempcelc_value);
         uart1_write_text(" Temp C");
         serial_nlcr();
         Lcd_out(2,1,"Temp     ");
         Lcd_out_cp(text);
         Lcd_out_cp("c");

}

void sensor_read(){
char bitcount;
TRISC.B2 = 0;   // set sensor line to output
LATC.B2 = 0;    //bring sensor line down
Delay_MS(10);   //wait time for sensor to see request
LATC.B2 = 1;    // bring sensor line high
Delay_US(20);   // wait for sensor to see
TRISC.B2 = 1;   // switch sensor line to input for pulse read

T1CON.TMR1ON = 0; //timer off

TMR1H = 0;        //clear timerh
TMR1L = 0;        //clear timerl to zero

T1CON.T1CKPS1=1;
T1CON.T1CKPS0=0; //set_Timer prescale  4:1

T1CON.TMR1ON; //switch on the timer
          while(bitcount <42){
              if (PIR1.CCP1IF == 1){
                 Buffer[bitcount] = CCPR1; //save timer value to buffer
                 T1CON.TMR1ON = 0; //switch off timer
                 TMR1H = 0;        //clear the timer
                 TMR1L = 0;
                 bitcount++ ;      // increment buffer pointer
                 T1CON.T1CKPS1=1;  //reset prescaller to
                 T1CON.T1CKPS0=0;  // set_Timer1 prescale 4:1
                 T1CON.TMR1ON = 1; //switch timer back on
                 PIR1.CCP1IF =0;   // clear capture compare flag
                 }
               }
          T1CON.TMR1ON = 0; //shut off the timer
          bitcount=0;


}
void initalise(){
//basic cpu setup
//designed for 8mhz clock 18f45k22
ANSELB = 0; // set port digital
ANSELC = 0; // Set port digital
ANSELD =0 ; //set port d as digital
TRISB.B7 = 0; //set port b for output
TRISC.B2 =1; // set ccp port as input
TRISD.B0 = 1; //set port d0 as input

CCP1CON = 0b00000100; //capture every falling edge.
//configure serial port
uart1_init(9600);
//timer 1 setup
T1CON.TMR1CS1 = 0;
T1CON.TMR1CS0 = 0;// select to internal instruction clock ... fosc/4
TMR1H = 0;
TMR1L = 0;
T1CON.TMR1ON = 0; //dont switch on yet
lcd_init(); //setup lcd display

}

void main() {
int index =2, bbindex=0;
int bitcount =0;
initalise();
while(1){

         sensor_read();      //read the Sensor
         convert_byte_bin(); //kludgy conversion routine to setup binary array
         LCD_CMD(_LCD_CLEAR);
         LCD_CMD(_LCD_CURSOR_OFF);
         data_conversion();  //convert binary array to human readabe format
         delay_MS(10000);    //wait 10 seconds and repeat.
         }
     }